#!/usr/local/bin/ruby18

################################
# ե
ConfigFile = 'config.yml'
################################

require 'erb'
require 'cgi'
require 'yaml'

#
# ե
class Config
	@@conf = nil
	#
	# 
	def initialize(file)
		unless @@conf
			@@conf = YAML::load( File.open(file) )
			
			#ǥե
			@@conf[:is_mobile] ||= false			# Хɽ뤫
			@@conf[:title] ||= 'coco'				# ȥ
			@@conf[:statfile] ||= 'stat.yml'		# ׾ե
			@@conf[:view_days] ||= 7				# ɽ
			@@conf[:sortby] ||= 'days'				# դǥ
			@@conf[:sortorder] ||= 'dsc'			# ߽ǥ
			@@conf[:view_row] ||= 'both'			# ɽ
			@@conf[:view_startpos] ||= 0			# ɽΰ
		end
	end

	#
	# config
	def self.get
		@@conf
	end
end

#
# ׾
class StatisticsManager
	#
	# 
	def initialize
		@conf = Config.get
		@statlist = YAML::load(File.open(@conf[:statfile]))
	end

	attr_reader :statlist
end

#
# ڡ
class ReminderBase
	include ERB::Util
	
	#
	MB = 1048576.0									# 1024 * 1024
	SecOfDay = 86400								# 60 * 60 * 24

	#
	# 
	def initialize
		@conf = Config.get
		@stat = StatisticsManager.new
	end

	#
	# HTML
	def to_html(cgi)
		if /DoCoMo/i =~ ENV['HTTP_USER_AGENT']
			@out_type = :text
			erb = ERB.new(html_mobile, nil, '<>')
		else
			@out_type = :html
			erb = ERB.new(html_normal, nil, '<>')
		end
		[@out_type, erb.result(binding)]
	end

	#
	# ꥯȽ
	def do_request(cgi)
	end

private
	#
	# ̥֥饦ѥڡ(إåեå)
	def html_normal
		body = erb_src_normal
		<<EOS
<?xml version="1.0" encoding="euc-jp"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja">
<head>
	<meta name="robots" content="noindex,nofollow" />
	<meta name="robots" content="noarchive" />
	<meta http-equiv="Content-Type" content="text/html; charset=euc-jp" />
	<meta http-equiv="Content-Style-Type" content="text/css" />
	<title>#{@conf[:title]}</title>
	<link rel="stylesheet" type="text/css" href="#{@conf[:css]}" />
<body>
<h1>#{@conf[:title]} - apricot׾</h1>
<div class="table">
<table border="1" frame="hsides" rules="groups" cellpadding="1" cellspacing="1" id="ave" summary="ʥӥ">
	<tr>
		<td><a href="view_days.rb">̽ɽ</a></td>
		<td><a href="view_days.rb">̽ɽ</a></td>
		<td><a href="view_days.rb">̽ɽ</a></td>
		
	</tr>
</table>
</div>
#{body}
<p id="copyright">Copyright &copy; 2005 <a href="http://yaya.sakura.ne.jp">Yaya</a></p>
</body>
</html>
EOS
	end

	#
	# ѥڡ(إåեå)
	def html_mobile
		erb_src_mobile
	end

	#
	# ̥֥饦ѥڡ
	def erb_src_normal
		''
	end

	#
	# ѥڡ
	def erb_src_mobile
		''
	end

	#
	# Сɽ
	def bar(type, val, max)
		return '' if val <= 0
		width = (val * @conf[type][:width] / max).to_i
		return "" if width == 0
		width = @conf[type][:width] if width > @conf[type][:width]
		%!<img src="#{@conf[type][:src]}" width="#{width}" height="#{@conf[type][:height]}" alt="" />!
	end

	#
	# ȥɽ
	def sortcsr(item, sortby, sortorder)
		return '' if item != sortby
		sortorder == 'asc' ? '' : ''
	end


	#
	# ץ̾
	def script_name(cgi)
		cgi.script_name
	end
	
	#
	# URLGETʸ(['key', val]Ϥ)
	def make_geturl(urlbase = '', hash = {}, array = [])
		url = urlbase.dup
		array.each{|a|
			url.concat( "&%s=%s" % [a[0], (hash[a[0]] || a[1])] )
		}
		url.sub(/\&/, '?')				# ǽ&?ѹ
	end

end

#
# 顼ڡ
class UnknownErrorPage
	include ERB::Util
	
	def initialize(error=$!, info=$@)
		@erb = ERB.new(erb_src, nil, '<>')
		@error = error
		@info = info
	end
	
	def erb_src
		<<EOS
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
	<title>coco - error</title>
</head>
<body>
<p><%=h @error%> - <%=h @error.class%></p>
<ul>
<% @info.each do |line| %>
	<li><%=h line%></li>
<% end %>
</ul>
</body>
</html>
EOS
	end
	
	def to_html
		[:html, @erb.result(binding)]
	end
end

#
# ᥤ
class Main
	#
	# 
	def initialize
		# եɤ߹
		Config.new(ConfigFile)
		@conf = Config.get
	end

	#
	# ¹
	def run(reminder = ReminderBase.new)
		cgi = CGI.new
		reminder.do_request(cgi)
		begin
			type, content = reminder.to_html(cgi)
		rescue
			type, content = UnknownErrorPage.new($!, $@).to_html
		end

		if type == :html
			cgi.out({'charset' => 'euc-jp'}) { content }
		else
			cgi.out('text/plain'){ content }
		end
	end
end

if $0 == __FILE__
	Main.new.run
end
