#!/usr/local/bin/ruby18

require 'erb'
require 'cgi'
require 'cocobase.rb'

#
# ڡ
class Reminder < ReminderBase
	#
	# 
	def initialize
		super
		@view_days = @conf[:view_days]			# ʬɽ뤫
		@view_startpos = @conf[:view_startpos]	# ɽΰ
		@sortorder = @conf[:sortorder]			# ȼ
		@sortby = @conf[:sortby]				# Ƚ
		@view_row = @conf[:view_row]			# ɽ
	end

	#
	# ꥯȽ
	def do_request(cgi)
		do_view_days(cgi)
		do_view_startpos(cgi)
		do_view_row(cgi)
		do_sortby(cgi)
		do_sortorder(cgi)
	end

private
	#
	# ɽѹ
	def do_view_days(cgi)
		item ,= cgi['vd']
		return if /\D/ =~ item					# ʳϤ
		return if item.to_i <= 0				# 0ʲϤ
		@view_days = item.to_i
	end

	#
	# ɽΰѹ
	def do_view_startpos(cgi)
		item ,= cgi['vs']
		return if /\D/ =~ item					# ʳϤ
		item = 0 if item.to_i <= 0				# 0ʲ0Ȥ
		@view_startpos = item.to_i
	end

	#
	# ɽѹ
	def do_view_row(cgi)
		item ,= cgi['vr']
		return unless %w(upper lower both).include?(item)
		@view_row = item
	end

	#
	# ѹ
	def do_sortby(cgi)
		item ,= cgi['sb']
		return unless %w(days uniq_num uniq_sz dup_num dup_sz all_num all_sz per_num per_sz times lapse_time).include?(item)
		@sortby = item
	end

	#
	# Ƚѹ
	def do_sortorder(cgi)
		item ,= cgi['so']
		return unless %w(asc dsc).include?(item)
		@sortorder = item
	end


	#
	# URLGETʸ
	def make_geturl(urlbase = '', hash = {})
		super((urlbase || ''), hash, [
			['vd', @view_days],
			['vs', @view_startpos],
			['vr', @view_row],
			['sb', @sortby],
			['so', @sortorder],
		])
	end


	#
	# Ͻ
	def prepare
		@slist = @stat.statlist[@view_startpos, @view_days]

		# ʿѤ׻
		today = Date.today
		if !@slist.empty? && (@slist[0][:date] == today)
			day = @slist.size - 1 +
				  (Time.now - Time.local(today.year, today.mon, today.day)) / SecOfDay
		else
			day = @slist.size
		end


		#  / Τ%׻
		@slist.each{|s|
			s[:per_sz] = (s[:all_sz] == 0) ? 0.0 : s[:uniq_sz] * 100.0 / s[:all_sz]
			s[:per_num] = (s[:all_sz] == 0) ? 0.0 : s[:uniq_num] * 100.0 / s[:all_num]
		}

		# ʿѡǹͤη׻
		@sinfo = Hash.new
		[:all_sz, :all_num, :uniq_sz, :uniq_num, :dup_sz,
		 :dup_num, :per_sz, :per_num, :times, :lapse_time].each{|t|
		 	@sinfo[t] = {:ave => 0, :max => 0}

			@slist.each{|s|
				@sinfo[t][:ave] += s[t]
				@sinfo[t][:max] = s[t] if @sinfo[t][:max] < s[t]
			}

			if t == :per_sz or t == :per_num
				# ʿͤñǳ
				@sinfo[t][:ave] /= @slist.size unless @slist.empty?
			else
				# ¾ʿͤ1̤ռƳ
				@sinfo[t][:ave] /= day.to_f if day != 0
			end
		}

		# 
		case @sortby
		when 'days'
			if @sortorder == 'asc'
				# վ祽
				@slist.reverse!
			end
		else
			if @sortorder == 'asc'
				# 祽
				@slist.sort!{|a, b| a[@sortby.intern] <=> b[@sortby.intern]}
			else
				# ߽祽
				@slist.sort!{|a, b| b[@sortby.intern] <=> a[@sortby.intern]}
			end
		end
	end


	#
	# ̥֥饦ѥڡ
	def erb_src_normal
		prepare
		<<EOS
<div class="table">
<form action="<%= script_name(cgi) %>" method="post">
	<input type="hidden" name="sb" value="<%= @sortby %>" />
	<input type="hidden" name="so" value="<%= @sortorder %>" />
	<input type="hidden" name="vs" value="<%= @view_startpos %>" />
	<table border="1" frame="border" rules="all" cellpadding="0" cellspacing="0" summary="ե">
	<colgroup span="1" />
		<tr>
			<td></td>
			<td><input type="text" name="vd" value="<%= @view_days %>" size="3" maxlength="3" /></td>
		</tr>
		<tr>
			<td>ɽ</td>
			<td>
			<% [['both', 'ξ'], ['upper', ''], ['lower', '']].each{|a| %>
				<input type="radio" name="vr" value="<%= a[0] %>" <%= 'checked="checked"' if @view_row == a[0] %>/><%= a[1] %>
			<% } %></td>
		</tr>
		<tr>
			<td colspan="2"><input type="submit" value="ѹ" /></td>
		</tr>
	</table>
</form>
</div>

<div class="table">
<table border="1" frame="hsides" rules="groups" cellpadding="0" cellspacing="0" id="ave" summary="̽ɽ" />
	<caption>
		̽ɽ
		<% if @view_startpos > 0 %>
			<span style="float:left"><a href="<%= make_geturl(script_name(cgi), {'vs' => @view_startpos - @view_days}) %>">&lt;&lt;<%= @view_days %></a></span>
		<% end %>
		(<em><%= @stat.statlist.size %></em><em><%= @view_startpos %> - <%= @view_startpos + @slist.size %></em>)
		<% if @view_startpos + @view_days < @stat.statlist.size %>
			<span style="float:right"><a href="<%= make_geturl(script_name(cgi), {'vs' => @view_startpos + @view_days}) %>"><%= @view_days %>&gt;&gt;</a></span>
		<% end %>
	</caption>
	<colgroup span="1" />
	<thead>
		<tr>
			<td<%= ' rowspan="2"' if @view_row == 'both' %>><a href="<%= make_geturl(script_name(cgi), {'sb' => 'days', 'so' => (@sortby == 'days' && @sortorder == 'dsc') ? 'asc' : 'dsc'}) %>"><%= sortcsr('days', @sortby, @sortorder) %></a></td>
<% unless @view_row == 'lower' %>
<%
[	['ե', 'uniq_num'], ['ʣե', 'dup_num'],
	['Υե', 'all_num'], ['/ο', 'per_num'],
	['apricotư', 'times']
].each{|a| %>
			<td><a href="<%= make_geturl(script_name(cgi), {'sb' => a[1], 'so' => (@sortby == a[1] && @sortorder == 'dsc') ? 'asc' : 'dsc'}) %>"><%= a[0] %><%= sortcsr(a[1], @sortby, @sortorder) %></a></td>
<% } %>
<% end %>
<% if @view_row == 'both' %>
		</tr>
		<tr>
<% end %>
<% unless @view_row == 'upper' %>
<%
[	['ե륵(MB)', 'uniq_sz'], ['ʣե륵(MB)', 'dup_sz'],
	['Υե륵(MB)', 'all_sz'], ['/Υ', 'per_sz'],
	['apricotư()', 'lapse_time']
].each{|a| %>
			<td><a href="<%= make_geturl(script_name(cgi), {'sb' => a[1], 'so' => (@sortby == a[1] && @sortorder == 'dsc') ? 'asc' : 'dsc'}) %>"><%= a[0] %><%= sortcsr(a[1], @sortby, @sortorder) %></a></td>
<% } %>
<% end %>
		</tr>
	</thead>
	<tfoot>
		<tr>
			<td<%= ' rowspan="2"' if @view_row == 'both' %>><%= @slist.size %>ʿ</td>
<% unless @view_row == 'lower' %>
<%
[
	[@sinfo[:uniq_num][:ave], @sinfo[:uniq_num][:max], "%d" % @sinfo[:uniq_num][:ave]],
	[@sinfo[:dup_num][:ave], @sinfo[:dup_num][:max], "%d" % @sinfo[:dup_num][:ave]],
	[@sinfo[:all_num][:ave], @sinfo[:all_num][:max], "%d" % @sinfo[:all_num][:ave]],
	[@sinfo[:per_num][:ave], 100, "%.1f%%" % @sinfo[:per_num][:ave]],
	[@sinfo[:times][:ave], @sinfo[:times][:max], "%.1f" % @sinfo[:times][:ave]],
].each{|a| %>
			<td><%= bar(:bar1, a[0], a[1]) %> <%= a[2] %></td>
<% } %>
<% end %>
<% if @view_row == 'both' %>
		</tr>
		<tr>
<% end %>
<% unless @view_row == 'upper' %>
<%
[
	[@sinfo[:uniq_sz][:ave], @sinfo[:uniq_sz][:max], "%d" % (@sinfo[:uniq_sz][:ave] / MB)],
	[@sinfo[:dup_sz][:ave], @sinfo[:dup_sz][:max], "%d" % (@sinfo[:dup_sz][:ave] / MB)],
	[@sinfo[:all_sz][:ave], @sinfo[:all_sz][:max], "%d" % (@sinfo[:all_sz][:ave] / MB)],
	[@sinfo[:per_sz][:ave], 100, "%.1f%%" % @sinfo[:per_sz][:ave]],
	[@sinfo[:lapse_time][:ave], @sinfo[:lapse_time][:max], "%d" % @sinfo[:lapse_time][:ave]],
].each{|a| %>
			<td><%= bar(:bar2, a[0], a[1]) %> <%= a[2] %></td>
<% } %>
<% end %>
		</tr>
	</tfoot>
	<tbody>
<% row = 'row_a' %>
<% @slist.each{|l| %>
		<tr class="<%= row %>">
			<td<%= ' rowspan="2"' if @view_row == 'both' %>><%= l[:date].strftime("%Y/%m/%d") %></td>
<% unless @view_row == 'lower' %>
<%
[	[l[:uniq_num], @sinfo[:uniq_num][:max], "%d" % l[:uniq_num]],
	[l[:dup_num], @sinfo[:dup_num][:max], "%d" % l[:dup_num]],
	[l[:all_num], @sinfo[:all_num][:max], "%d" % l[:all_num]],
	[l[:per_num], 100, "%.1f%%" % l[:per_num]],
	[l[:times], @sinfo[:times][:max], "%d" % l[:times]],
].each{|a| %>
			<td><%= bar(:bar1, a[0], a[1]) %> <%= a[2] %></td>
<% } %>
<% end %>
<% if @view_row == 'both' %>
		</tr>
		<tr class="<%= row %>">
<% end %>
<% unless @view_row == 'upper' %>
<%
[	[l[:uniq_sz], @sinfo[:uniq_sz][:max], "%d" % (l[:uniq_sz] / MB)],
	[l[:dup_sz], @sinfo[:dup_sz][:max], "%d" % (l[:dup_sz] / MB)],
	[l[:all_sz], @sinfo[:all_sz][:max], "%d" % (l[:all_sz] / MB)],
	[l[:per_sz], 100, "%.1f%%" % l[:per_sz]],
	[l[:lapse_time], @sinfo[:lapse_time][:max], "%d" % l[:lapse_time]],
].each{|a| %>
			<td><%= bar(:bar2, a[0], a[1]) %> <%= a[2] %></td>
<% } %>
<% end %>
		</tr>
<% row = (row == 'row_a' ? 'row_b' : 'row_a') %>
<% } %>
	</tbody>
</table>
</div>
EOS
	end

	#
	# ѥڡ
	def erb_src_mobile
		prepare
		<<EOS
[<%= "%2d" % @slist.size %>ʿ]     <%= "%4.1f%%" % @sinfo[:per_sz][:ave] %>
<%= "%6.2f/%6.2f/%6.2f" % [@sinfo[:uniq_num][:ave], @sinfo[:dup_num][:ave], @sinfo[:all_num][:ave]] %>

<%= "%6d/%6d/%6d" % [@sinfo[:uniq_sz][:ave] / MB, @sinfo[:dup_sz][:ave] / MB, @sinfo[:all_sz][:ave] / MB] %>

<% @slist.each{|l| %>
[<%= l[:date].strftime("%Y/%m/%d") %>]   <%= "%4.1f%%" % l[:per_sz] %>
<%= "%6d/%6d/%6d" % [l[:uniq_num], l[:dup_num],  l[:all_num]] %>

<%= "%6d/%6d/%6d" % [l[:uniq_sz] / MB, l[:dup_sz] / MB, l[:all_sz] / MB] %>

<% } %>
EOS
	end
end

Main.new.run(Reminder.new)
